// program that calculates y[:] = a*x[:] + y[:]
#include <iostream>
#include <sys/time.h>
#include <cmath>
#include <cstdlib>

using namespace std;

double drand() {
  static bool first=true;
  if (first) {    
    srand(12345);
    first=false;
  }
  return rand()/double(RAND_MAX); 
}

double wtime() {
   struct timeval tp;
   gettimeofday(&tp, NULL);
   return (double) (tp.tv_sec + tp.tv_usec/1000000.0); 
}

int main(int argc, char *argv[]) {

   // set
   int n=0;
   if (argc == 2) 
      n = atoi(argv[1]);
   else {
      cerr << "usage: "<< argv[0] << " <n>" << endl;
      exit(1);
   }

   // allocate vectors
   float *x = new float[n];
   float *y = new float[n];

   // set a and fill vectors with random values
   float a = 3.0; //drand();
   for (int i=0; i<n; i++) {
      x[i] = 1.0; //drand();
      y[i] = 2.0; //drand();
   }

   // start timer
   double wstart = wtime();

   // compute ax+y
   for (int i=0; i<n; i++)
      y[i] = a*x[i] + y[i];

   double wstop  = wtime();

   // compute norm of y for sanity check
   double norm = 0.0; 
   for (int i=0; i<n; i++) norm += y[i]*y[i];
   double sqen = sqrt(n)*5;  

   cout << "Norm of y[:] (expected value is " << sqen << ") = " << sqrt(norm) << endl;
   cout << "Time to compute (single CPU thread) [ms] = " << (wstop-wstart)*1000.0 << endl;

}


